//	SwapTankPositions.cpp - When triggered, swaps positions with another random
//							tank.
//  ----------------------------------------------------------------------------
//	This file is part of 'NiallsAVLib', base code for any kind of audiovisual
//	apps.
//	Copyright (C) 2012  Niall Moody
//	
//	This program is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program.  If not, see <http://www.gnu.org/licenses/>.
//	----------------------------------------------------------------------------

#include "SwapTankPositions.h"
#include "GamePlayState.h"
#include "Random.h"
#include "Mine.h"
#include "Tank.h"

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
SwapTankPositions::SwapTankPositions():
ModifierCreator(1)
{

}

//------------------------------------------------------------------------------
SwapTankPositions::~SwapTankPositions()
{

}

//------------------------------------------------------------------------------
void SwapTankPositions::apply(GamePlayState& state)
{
	int i;

	for(i=0;i<state.getNumTanks();++i)
		state.getTank(i)->addSecondaryTrigger(shared_ptr<SecondaryModifier>(new SwapTankPositionsTrigger()));
}

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
SwapTankPositionsTrigger::SwapTankPositionsTrigger()
{

}
//------------------------------------------------------------------------------
SwapTankPositionsTrigger::~SwapTankPositionsTrigger()
{

}

//------------------------------------------------------------------------------
void SwapTankPositionsTrigger::trigger(Tank& tank, GamePlayState& state)
{
	TwoFloats tempPos;
	bool found = false;
	int i = Random::getGlobal().getRandomInt(state.getNumTanks());

	while(!found)
	{
		Tank& otherTank = *(state.getTank(i));

		if((otherTank == tank) || (otherTank.getDead()))
		{
			++i;
			if(i >= state.getNumTanks())
				i = 0;
		}
		else
			found = true;
	}

	tempPos = tank.getPosition();
	tank.setPosition(state.getTank(i)->getPosition());
	state.getTank(i)->setPosition(tempPos);
}
